package atvI;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;
import java.util.Comparator;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 *
 * @author Lucas Matos
 */
public class ViewDados extends javax.swing.JFrame {
	private List<Distancia> distancias;

	/**
	 * Creates new form NewJFrame
	 */
	public ViewDados() {
		initComponents();
		setResizable(false);
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jPanel1 = new javax.swing.JPanel();
		jLabel2 = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		jLabel4 = new javax.swing.JLabel();
		jLabel5 = new javax.swing.JLabel();
		jLabel6 = new javax.swing.JLabel();
		txtopcao = new javax.swing.JTextField();
		btnConfirmar = new javax.swing.JButton();
		btnCancelar = new javax.swing.JButton();
		jPanel2 = new javax.swing.JPanel();
		jLabel7 = new javax.swing.JLabel();

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

		jPanel1.setBorder(new javax.swing.border.MatteBorder(null));

		jLabel2.setText("Digite opções de exibição com Streams:");

		jLabel3.setText("1 - Simples");

		jLabel4.setText("2 - Cinco Distâncias impares");

		jLabel5.setText("3 - Ordem Crescente");

		jLabel6.setText("4 - Ordem Decrescente ( mostre apenas distâncias)");

		txtopcao.addKeyListener(new KeyListener() {
			@Override
			public void keyTyped(KeyEvent e) {
				char c = e.getKeyChar();
				if (!Character.isDigit(c)) {
					e.consume(); // Impede a inserção de caracteres não numéricos
				}
			}

			@Override
			public void keyPressed(KeyEvent e) {
				// TODO Auto-generated method stub

			}

			@Override
			public void keyReleased(KeyEvent e) {
				// TODO Auto-generated method stub

			}
		});

		btnConfirmar.setText("Confirmar");
		btnConfirmar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btnConfirmarActionPerformed(evt);
			}
		});

		btnCancelar.setText("Cancelar");
		btnCancelar.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btnCancelarActionPerformed(evt);
			}
		});

		javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
		jPanel1.setLayout(jPanel1Layout);
		jPanel1Layout.setHorizontalGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(jPanel1Layout.createSequentialGroup().addGroup(jPanel1Layout
						.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(jLabel2))
						.addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(jLabel3))
						.addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(jLabel4))
						.addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(jLabel5))
						.addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(jLabel6))
						.addGroup(jPanel1Layout.createSequentialGroup().addGap(20, 20, 20).addComponent(txtopcao,
								javax.swing.GroupLayout.PREFERRED_SIZE, 349, javax.swing.GroupLayout.PREFERRED_SIZE))
						.addGroup(jPanel1Layout.createSequentialGroup().addGap(65, 65, 65).addComponent(btnConfirmar)
								.addGap(55, 55, 55).addComponent(btnCancelar, javax.swing.GroupLayout.PREFERRED_SIZE,
										85, javax.swing.GroupLayout.PREFERRED_SIZE)))
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));
		jPanel1Layout.setVerticalGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(jPanel1Layout.createSequentialGroup().addGap(34, 34, 34).addComponent(jLabel2)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel3)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel4)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel5)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel6)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
						.addComponent(txtopcao, javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED,
								javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
						.addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
								.addComponent(btnConfirmar).addComponent(btnCancelar,
										javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE,
										javax.swing.GroupLayout.PREFERRED_SIZE))));

		jPanel2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));

		jLabel7.setText("Input");

		javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
		jPanel2.setLayout(jPanel2Layout);
		jPanel2Layout.setHorizontalGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(jPanel2Layout
						.createSequentialGroup().addGap(170, 170, 170).addComponent(jLabel7,
								javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
						.addContainerGap(149, Short.MAX_VALUE)));
		jPanel2Layout.setVerticalGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, 22, Short.MAX_VALUE));

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup().addContainerGap()
						.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
								.addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE,
										javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
								.addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE,
										javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
						.addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));
		layout.setVerticalGroup(
				layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
								.addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE,
										javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
								.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED,
										javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE,
										javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
								.addContainerGap()));

		pack();
	}// </editor-fold>

	private void btnConfirmarActionPerformed(java.awt.event.ActionEvent evt) {
		String opcao = txtopcao.getText().trim();

		if (!opcao.isEmpty()) {
			int opcaoNumero = Integer.parseInt(opcao);
			switch (opcaoNumero) {
			case 1:
				mostrarDistancia("1");
				break;
			case 2:
				mostrarDistancia("2");
				break;
			case 3:
				mostrarDistancia("3");
				break;
			case 4:
				mostrarDistancia("4");
				break;
			default:
				JOptionPane.showMessageDialog(this, "Opção inválida. Por favor, escolha uma opção válida.", "Error",
						JOptionPane.ERROR_MESSAGE);
				break;
			}
		}
	}

	private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {
		txtopcao.setText("");
	}

	private void mostrarDistancia(String option) {
		if (distancias == null) {
			try {
				distancias = Utils.lerDistancias("src/cidades.csv");
			} catch (IOException e) {
				JOptionPane.showMessageDialog(this, "Erro ao ler o arquivo de distâncias.", "Error",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
		}

		JTextArea outputTextArea = new JTextArea();
		JScrollPane scrollPane = new JScrollPane(outputTextArea);

		switch (option) {
		case "1":
			distancias.forEach(distancia -> outputTextArea.append(distancia.toString() + "\n"));
			break;
		case "2":
			distancias.stream().filter(distancia -> distancia.getDist() % 2 != 0).limit(5)
					.forEach(distancia -> outputTextArea.append(distancia.toString() + "\n"));
			break;
		case "3":
			distancias.stream().sorted(Comparator.comparing(Distancia::getDist))
					.forEach(distancia -> outputTextArea.append(distancia.toString() + "\n"));
			break;
		case "4":
			 distancias.stream()
             .sorted(Comparator.comparing(Distancia::getDist).reversed())
             .forEach(distancia -> outputTextArea.append(distancia.getDist() + "\n"));

			break;
		default:
			break;
		}

		JFrame resultsFrame = new JFrame("Resultados");
		resultsFrame.setSize(400, 300);
		resultsFrame.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		resultsFrame.add(scrollPane);
		resultsFrame.setVisible(true);
	}


	// Variables declaration - do not modify
	private javax.swing.JButton btnCancelar;
	private javax.swing.JButton btnConfirmar;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JLabel jLabel5;
	private javax.swing.JLabel jLabel6;
	private javax.swing.JLabel jLabel7;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JTextField txtopcao;
	// End of variables declaration
}
